<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1" />
<meta name="generator" content="pdoc 0.5.3" />
<title>prepare_initial_index API documentation</title>
<meta name="description" content="" />
<link href='https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.0/normalize.min.css' rel='stylesheet'>
<link href='https://cdnjs.cloudflare.com/ajax/libs/10up-sanitize.css/8.0.0/sanitize.min.css' rel='stylesheet'>
<link href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" rel="stylesheet">
<style>.flex{display:flex !important}body{line-height:1.5em}#content{padding:20px}#sidebar{padding:30px;overflow:hidden}.http-server-breadcrumbs{font-size:130%;margin:0 0 15px 0}#footer{font-size:.75em;padding:5px 30px;border-top:1px solid #ddd;text-align:right}#footer p{margin:0 0 0 1em;display:inline-block}#footer p:last-child{margin-right:30px}h1,h2,h3,h4,h5{font-weight:300}h1{font-size:2.5em;line-height:1.1em}h2{font-size:1.75em;margin:1em 0 .50em 0}h3{font-size:1.4em;margin:25px 0 10px 0}h4{margin:0;font-size:105%}a{color:#058;text-decoration:none;transition:color .3s ease-in-out}a:hover{color:#e82}.title code{font-weight:bold}h2[id^="header-"]{margin-top:2em}.ident{color:#900}pre code{background:#f8f8f8;font-size:.8em;line-height:1.4em}code{background:#f2f2f1;padding:1px 4px;overflow-wrap:break-word}h1 code{background:transparent}pre{background:#f8f8f8;border:0;border-top:1px solid #ccc;border-bottom:1px solid #ccc;margin:1em 0;padding:1ex}#http-server-module-list{display:flex;flex-flow:column}#http-server-module-list div{display:flex}#http-server-module-list dt{min-width:10%}#http-server-module-list p{margin-top:0}.toc ul,#index{list-style-type:none;margin:0;padding:0}#index code{background:transparent}#index h3{border-bottom:1px solid #ddd}#index ul{padding:0}#index h4{font-weight:bold}#index h4 + ul{margin-bottom:.6em}@media (min-width:200ex){#index .two-column{column-count:2}}@media (min-width:300ex){#index .two-column{column-count:3}}dl{margin-bottom:2em}dl dl:last-child{margin-bottom:4em}dd{margin:0 0 1em 3em}#header-classes + dl > dd{margin-bottom:3em}dd dd{margin-left:2em}dd p{margin:10px 0}.name{background:#eee;font-weight:bold;font-size:.85em;padding:5px 10px;display:inline-block;min-width:40%}.name:hover{background:#e0e0e0}.name > span:first-child{white-space:nowrap}.name.class > span:nth-child(2){margin-left:.4em}.name small{font-weight:normal}.inherited{color:#999;border-left:5px solid #eee;padding-left:1em}.inheritance em{font-style:normal;font-weight:bold}.desc h2{font-weight:400;font-size:1.25em}.desc h3{font-size:1em}.desc dt code{background:inherit}.source summary{color:#666;text-align:right;font-weight:400;font-size:.8em;text-transform:uppercase;cursor:pointer}.source pre{max-height:500px;overflow:auto;margin:0}.source pre code{font-size:12px;overflow:visible}.hlist{list-style:none}.hlist li{display:inline}.hlist li:after{content:',\2002'}.hlist li:last-child:after{content:none}.hlist .hlist{display:inline;padding-left:1em}img{max-width:100%}.admonition{padding:.1em .5em}.admonition-title{font-weight:bold}.admonition.note,.admonition.info,.admonition.important{background:#aef}.admonition.todo,.admonition.versionadded,.admonition.tip,.admonition.hint{background:#dfd}.admonition.warning,.admonition.versionchanged,.admonition.deprecated{background:#fd4}.admonition.error,.admonition.danger,.admonition.caution{background:lightpink}</style>
<style media="screen and (min-width: 700px)">@media screen and (min-width:700px){#sidebar{width:30%}#content{width:70%;max-width:100ch;padding:3em 4em;border-left:1px solid #ddd}pre code{font-size:1em}.item .name{font-size:1em}main{display:flex;flex-direction:row-reverse;justify-content:flex-end}.toc ul ul,#index ul{padding-left:1.5em}.toc > ul > li{margin-top:.5em}}</style>
<style media="print">@media print{#sidebar h1{page-break-before:always}.source{display:none}}@media print{*{background:transparent !important;color:#000 !important;box-shadow:none !important;text-shadow:none !important}a[href]:after{content:" (" attr(href) ")";font-size:90%}a[href][title]:after{content:none}abbr[title]:after{content:" (" attr(title) ")"}.ir a:after,a[href^="javascript:"]:after,a[href^="#"]:after{content:""}pre,blockquote{border:1px solid #999;page-break-inside:avoid}thead{display:table-header-group}tr,img{page-break-inside:avoid}img{max-width:100% !important}@page{margin:0.5cm}p,h2,h3{orphans:3;widows:3}h1,h2,h3,h4,h5,h6{page-break-after:avoid}}</style>
</head>
<body>
<main>
<article id="content">
<header>
<h1 class="title"><code>prepare_initial_index</code> module</h1>
</header>
<section id="section-intro">
<details class="source">
<summary>Source code</summary>
<pre><code class="python">import os
import json
from sklearn.externals import joblib
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.decomposition import LatentDirichletAllocation

ARTICLE_MAIN_DIR = &#34;all_texts/&#34;
MIN_LENGTH = 250
ES_INDEX = &#34;topic_docs&#34;
ES_TYPE = &#34;article&#34;

def prepare_articles():
    &#34;&#34;&#34;Load articles from the wikidump.
    
    This traverses all directories with articles extracted using the 
    wikiextractor. It loads all articles and their meta data into lists
    provided they have a minimum length (default 250 words).
    Filtering out very short articles is beneficial for the topic modeling
    process.&#34;&#34;&#34;
    # contain raw articles / articles with metadata as json respectively
    articles, articles_meta = list(), list()
    for directory in os.listdir(ARTICLE_MAIN_DIR):
        for _file in os.listdir(ARTICLE_MAIN_DIR + directory): 
            with open(&#34;{}{}/{}&#34;.format(ARTICLE_MAIN_DIR, directory, _file)) as article_file:
                for line in article_file.readlines():
                    article = json.loads(line)
                    # only use articles that have MIN_LENGTH nr. of words or more
                    if(len(article[&#34;text&#34;].split()) &gt; MIN_LENGTH):
                        articles_meta.append(article)
                        articles.append(article[&#34;text&#34;])
    return articles, articles_meta


def get_term_frequencies(articles):
    &#34;&#34;&#34;Transform a list of articles into a document-termfrequency matrix.
    
    Each articles is split into words. Numbers, words with less than 3 characters,
    words appearing only once in the corpus and words appearing in more than 90 percent of 
    articles are disregarded. Stopwords contained in the standard stopword list for english 
    provided by sklearn are filtered out as well. 
    The 10000 most frequent of the remaining words are kept.&#34;&#34;&#34;
    tf_vectorizer = CountVectorizer(max_df=0.90, 
                                token_pattern=&#39;[a-zA-Z]{3,}&#39;,
                                min_df=2, max_features=10000, stop_words=&#39;english&#39;)
    tf = tf_vectorizer.fit_transform(articles)
    return tf, tf_vectorizer.get_feature_names()


def run_lda(term_frequencies, n_topics=25):
    &#34;&#34;&#34;Run the lda algorithm on all available cores. 

    Keyword Arguments:  
    `term_frequencies`: the document-term-frequency matrix  
    `n_topics`: the number of topics (default = 25)
    &#34;&#34;&#34;
    lda = LatentDirichletAllocation(n_components=n_topics, max_iter=5, n_jobs = -1, 
                                learning_method=&#39;online&#39;, random_state=0).fit(term_frequencies)
    return lda    

        
def display_topics(model, features, no_top_words):
    &#34;&#34;&#34;Print the most significant words of each of the found topics.  
    
    Keyword Arguments:  
    `model`: the trained lda model    
    `features`: the words corresponding to features  
    `no_top_words`: the number of words to print for each topic
    &#34;&#34;&#34;
    for topic_idx, topic in enumerate(model.components_):
        print(&#34;Topic {}:&#34;.format(topic_idx))
        print(&#34; &#34;.join([features[i] for i in topic.argsort()[:-no_top_words - 1:-1]]))


def prepare_to_index(lda, tfs, articles_meta):
    &#34;&#34;&#34; Calculate topic distribution for each article and add that information.
    Returns a list of the articles, enriched with topic information and elasticsearch
    attributes.

    Takes a list of articles and their meta data in json format, calculates the topic
    distribution of the article and adds that information to the articles json.
    Additionaly the elasticsearch index, document type and id are added.

    Keyword Arguments:
    `lda`: the lda model used to transform the articles
    `tfs`: the term-frequencies of the provided articles
    `articles_meta`: the articles for which to compute the topic distribution
    &#34;&#34;&#34;
    to_index = articles_meta
    for idx, doc in enumerate(tfs):
        t_dist = lda.transform(doc)
        for dist_key, dist_v in enumerate(t_dist.flatten()):
            to_index[idx][&#34;topic_{}&#34;.format(dist_key)] = dist_v
        to_index[idx][&#34;_id&#34;] = str(idx)
        to_index[idx][&#34;_index&#34;] = ES_INDEX
        to_index[idx][&#34;_type&#34;] =  ES_TYPE
    return(to_index)


def prepare_initial_index():
    &#34;&#34;&#34; Load 50000 articles from the wikipedia dump, train an lda model on them and save
    everything needed to index the articles.

    Trains the LDA-Model and saves the model and vocabulary so that new documents can be
    indexed with those files. Also adds topic information to the initial corpus und saves 
    the enriched list of articles that is ready to index in elasticsearch.
    
    &#34;&#34;&#34;
    articles, articles_meta = prepare_articles()
    # use the first 50000 articles
    articles = articles[:50000]
    articles_meta = articles_meta[:50000]
    tfs, feature_names = get_term_frequencies(articles)
    joblib.dump(feature_names, &#34;vocabulary.pkl&#34;)
    lda = run_lda(tfs, 25)
    display_topics(lda, feature_names, 10)
    joblib.dump(lda, &#34;mylda.pkl&#34;)
    to_index = prepare_to_index(lda, tfs, articles_meta)
    with open(&#34;to_index.pkl&#34;, &#34;wb&#34;) as ti:
        joblib.dump(to_index, ti)

if __name__ == &#34;__main__&#34;:
    prepare_initial_index()</code></pre>
</details>
</section>
<section>
</section>
<section>
</section>
<section>
<h2 class="section-title" id="header-functions">Functions</h2>
<dl>
<dt id="prepare_initial_index.display_topics"><code class="name flex">
<span>def <span class="ident">display_topics</span></span>(<span>model, features, no_top_words)</span>
</code></dt>
<dd>
<section class="desc"><p>Print the most significant words of each of the found topics.
</p>
<p>Keyword Arguments:<br>
<code>model</code>: the trained lda model
<br>
<code>features</code>: the words corresponding to features<br>
<code>no_top_words</code>: the number of words to print for each topic</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def display_topics(model, features, no_top_words):
    &#34;&#34;&#34;Print the most significant words of each of the found topics.  
    
    Keyword Arguments:  
    `model`: the trained lda model    
    `features`: the words corresponding to features  
    `no_top_words`: the number of words to print for each topic
    &#34;&#34;&#34;
    for topic_idx, topic in enumerate(model.components_):
        print(&#34;Topic {}:&#34;.format(topic_idx))
        print(&#34; &#34;.join([features[i] for i in topic.argsort()[:-no_top_words - 1:-1]]))</code></pre>
</details>
</dd>
<dt id="prepare_initial_index.get_term_frequencies"><code class="name flex">
<span>def <span class="ident">get_term_frequencies</span></span>(<span>articles)</span>
</code></dt>
<dd>
<section class="desc"><p>Transform a list of articles into a document-termfrequency matrix.</p>
<p>Each articles is split into words. Numbers, words with less than 3 characters,
words appearing only once in the corpus and words appearing in more than 90 percent of
articles are disregarded. Stopwords contained in the standard stopword list for english
provided by sklearn are filtered out as well.
The 10000 most frequent of the remaining words are kept.</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def get_term_frequencies(articles):
    &#34;&#34;&#34;Transform a list of articles into a document-termfrequency matrix.
    
    Each articles is split into words. Numbers, words with less than 3 characters,
    words appearing only once in the corpus and words appearing in more than 90 percent of 
    articles are disregarded. Stopwords contained in the standard stopword list for english 
    provided by sklearn are filtered out as well. 
    The 10000 most frequent of the remaining words are kept.&#34;&#34;&#34;
    tf_vectorizer = CountVectorizer(max_df=0.90, 
                                token_pattern=&#39;[a-zA-Z]{3,}&#39;,
                                min_df=2, max_features=10000, stop_words=&#39;english&#39;)
    tf = tf_vectorizer.fit_transform(articles)
    return tf, tf_vectorizer.get_feature_names()</code></pre>
</details>
</dd>
<dt id="prepare_initial_index.prepare_articles"><code class="name flex">
<span>def <span class="ident">prepare_articles</span></span>(<span>)</span>
</code></dt>
<dd>
<section class="desc"><p>Load articles from the wikidump.</p>
<p>This traverses all directories with articles extracted using the
wikiextractor. It loads all articles and their meta data into lists
provided they have a minimum length (default 250 words).
Filtering out very short articles is beneficial for the topic modeling
process.</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def prepare_articles():
    &#34;&#34;&#34;Load articles from the wikidump.
    
    This traverses all directories with articles extracted using the 
    wikiextractor. It loads all articles and their meta data into lists
    provided they have a minimum length (default 250 words).
    Filtering out very short articles is beneficial for the topic modeling
    process.&#34;&#34;&#34;
    # contain raw articles / articles with metadata as json respectively
    articles, articles_meta = list(), list()
    for directory in os.listdir(ARTICLE_MAIN_DIR):
        for _file in os.listdir(ARTICLE_MAIN_DIR + directory): 
            with open(&#34;{}{}/{}&#34;.format(ARTICLE_MAIN_DIR, directory, _file)) as article_file:
                for line in article_file.readlines():
                    article = json.loads(line)
                    # only use articles that have MIN_LENGTH nr. of words or more
                    if(len(article[&#34;text&#34;].split()) &gt; MIN_LENGTH):
                        articles_meta.append(article)
                        articles.append(article[&#34;text&#34;])
    return articles, articles_meta</code></pre>
</details>
</dd>
<dt id="prepare_initial_index.prepare_initial_index"><code class="name flex">
<span>def <span class="ident">prepare_initial_index</span></span>(<span>)</span>
</code></dt>
<dd>
<section class="desc"><p>Load 50000 articles from the wikipedia dump, train an lda model on them and save
everything needed to index the articles.</p>
<p>Trains the LDA-Model and saves the model and vocabulary so that new documents can be
indexed with those files. Also adds topic information to the initial corpus und saves
the enriched list of articles that is ready to index in elasticsearch.</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def prepare_initial_index():
    &#34;&#34;&#34; Load 50000 articles from the wikipedia dump, train an lda model on them and save
    everything needed to index the articles.

    Trains the LDA-Model and saves the model and vocabulary so that new documents can be
    indexed with those files. Also adds topic information to the initial corpus und saves 
    the enriched list of articles that is ready to index in elasticsearch.
    
    &#34;&#34;&#34;
    articles, articles_meta = prepare_articles()
    # use the first 50000 articles
    articles = articles[:50000]
    articles_meta = articles_meta[:50000]
    tfs, feature_names = get_term_frequencies(articles)
    joblib.dump(feature_names, &#34;vocabulary.pkl&#34;)
    lda = run_lda(tfs, 25)
    display_topics(lda, feature_names, 10)
    joblib.dump(lda, &#34;mylda.pkl&#34;)
    to_index = prepare_to_index(lda, tfs, articles_meta)
    with open(&#34;to_index.pkl&#34;, &#34;wb&#34;) as ti:
        joblib.dump(to_index, ti)</code></pre>
</details>
</dd>
<dt id="prepare_initial_index.prepare_to_index"><code class="name flex">
<span>def <span class="ident">prepare_to_index</span></span>(<span>lda, tfs, articles_meta)</span>
</code></dt>
<dd>
<section class="desc"><p>Calculate topic distribution for each article and add that information.
Returns a list of the articles, enriched with topic information and elasticsearch
attributes.</p>
<p>Takes a list of articles and their meta data in json format, calculates the topic
distribution of the article and adds that information to the articles json.
Additionaly the elasticsearch index, document type and id are added.</p>
<p>Keyword Arguments:
<code>lda</code>: the lda model used to transform the articles
<code>tfs</code>: the term-frequencies of the provided articles
<code>articles_meta</code>: the articles for which to compute the topic distribution</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def prepare_to_index(lda, tfs, articles_meta):
    &#34;&#34;&#34; Calculate topic distribution for each article and add that information.
    Returns a list of the articles, enriched with topic information and elasticsearch
    attributes.

    Takes a list of articles and their meta data in json format, calculates the topic
    distribution of the article and adds that information to the articles json.
    Additionaly the elasticsearch index, document type and id are added.

    Keyword Arguments:
    `lda`: the lda model used to transform the articles
    `tfs`: the term-frequencies of the provided articles
    `articles_meta`: the articles for which to compute the topic distribution
    &#34;&#34;&#34;
    to_index = articles_meta
    for idx, doc in enumerate(tfs):
        t_dist = lda.transform(doc)
        for dist_key, dist_v in enumerate(t_dist.flatten()):
            to_index[idx][&#34;topic_{}&#34;.format(dist_key)] = dist_v
        to_index[idx][&#34;_id&#34;] = str(idx)
        to_index[idx][&#34;_index&#34;] = ES_INDEX
        to_index[idx][&#34;_type&#34;] =  ES_TYPE
    return(to_index)</code></pre>
</details>
</dd>
<dt id="prepare_initial_index.run_lda"><code class="name flex">
<span>def <span class="ident">run_lda</span></span>(<span>term_frequencies, n_topics=25)</span>
</code></dt>
<dd>
<section class="desc"><p>Run the lda algorithm on all available cores. </p>
<p>Keyword Arguments:<br>
<code>term_frequencies</code>: the document-term-frequency matrix<br>
<code>n_topics</code>: the number of topics (default = 25)</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def run_lda(term_frequencies, n_topics=25):
    &#34;&#34;&#34;Run the lda algorithm on all available cores. 

    Keyword Arguments:  
    `term_frequencies`: the document-term-frequency matrix  
    `n_topics`: the number of topics (default = 25)
    &#34;&#34;&#34;
    lda = LatentDirichletAllocation(n_components=n_topics, max_iter=5, n_jobs = -1, 
                                learning_method=&#39;online&#39;, random_state=0).fit(term_frequencies)
    return lda    </code></pre>
</details>
</dd>
</dl>
</section>
<section>
</section>
</article>
<nav id="sidebar">
<h1>Index</h1>
<div class="toc">
<ul></ul>
</div>
<ul id="index">
<li><h3><a href="#header-functions">Functions</a></h3>
<ul class="">
<li><code><a title="prepare_initial_index.display_topics" href="#prepare_initial_index.display_topics">display_topics</a></code></li>
<li><code><a title="prepare_initial_index.get_term_frequencies" href="#prepare_initial_index.get_term_frequencies">get_term_frequencies</a></code></li>
<li><code><a title="prepare_initial_index.prepare_articles" href="#prepare_initial_index.prepare_articles">prepare_articles</a></code></li>
<li><code><a title="prepare_initial_index.prepare_initial_index" href="#prepare_initial_index.prepare_initial_index">prepare_initial_index</a></code></li>
<li><code><a title="prepare_initial_index.prepare_to_index" href="#prepare_initial_index.prepare_to_index">prepare_to_index</a></code></li>
<li><code><a title="prepare_initial_index.run_lda" href="#prepare_initial_index.run_lda">run_lda</a></code></li>
</ul>
</li>
</ul>
</nav>
</main>
<footer id="footer">
<p>Generated by <a href="https://pdoc3.github.io/pdoc"><cite>pdoc</cite> 0.5.3</a>.</p>
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
<script>hljs.initHighlightingOnLoad()</script>
</body>
</html>